package com.biganto.visual.roompark.data.data_provider

import com.biganto.visual.androidplayer.data.repository.local.ILocalStore
import com.biganto.visual.roompark.data.local.UserState
import com.biganto.visual.roompark.data.repository.api.IRoomParkApi
import com.biganto.visual.roompark.data.repository.db.IDb
import com.biganto.visual.roompark.domain.contract.DealContract
import com.biganto.visual.roompark.domain.custom_exception.CustomApiException
import com.biganto.visual.roompark.domain.model.EstateModel
import timber.log.Timber
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 29.10.2019.
 */
//


class EstateRepository @Inject constructor(
    private val local: ILocalStore,
    private val api: IRoomParkApi,
    private val db: IDb
): DealContract{
    init {
        Timber.d("Estate Repository Created")
    }

    val getFavoritesApi =
        local.recentUser()
            .flatMap{ when(it){
            is UserState.Authenticated -> db.fetchUser(it.uuid.toInt())
            else -> throw CustomApiException.NotAuthorizedException()
        } }
            .flatMap { api.getFavorites(it.authToken)
//                .map(::fromRaw)
            }

    override fun getFavorites(): io.reactivex.rxjava3.core.Observable<List<EstateModel>> {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }


}
